maptext = {}

maptext.hudtxts = {}

function table.contains(tbl,el)
	for k,v in pairs(tbl) do
		if v==el then
			return true
		end
	end
	return false
end

function string.split(str,pat)
	local tbl = {}
	pat = pat or "[^%s]+"
	for word in str:gmatch(pat) do
		tbl[#tbl+1] = word
	end
	return tbl
end

function colourcode(r,g,b)
	r, g, b = tostring(r), tostring(g), tostring(b)
	return ("0"):rep(3-#r)..r..("0"):rep(3-#g)..g..("0"):rep(3-#b)..b
end



setmetatable(maptext,{
	__call = function(_, id, ply, txt, x, y, mode, align)
	if (type(ply) == "number" and ply ~= 0) then ply = {ply} end
	maptext.hudtxts[id] = {txt, x, y, ply or 0, align or 0, mode}
	
	if (mode == 0) then
		if (not ply or ply == 0) then
			for i = 1, 32 do
				if (player(i, "exists")) then
					parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..320+(x-player(i, "x")).." "..240+(y-player(i, "y")).." "..(align or 0))
				end
			end
		else
			for _, i in pairs(ply) do
				if (player(i, "exists")) then
					parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..320+(x-player(i, "x")).." "..240+(y-player(i, "y")).." "..(align or 0))
				end
			end
		end
	elseif (mode == 1) then
		if (not ply or ply == 0) then
			for i = 1, 32 do
				if (player(i, "exists")) then
					parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..x.." "..y.." "..(align or 0))
				end
			end
		else
			for _, i in pairs(ply) do
				if (player(i, "exists")) then
					parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..x.." "..y.." "..(align or 0))
				end
			end
		end
	else
		local i = mode - 100
		
		if (not ply or ply == 0) then
			for ii = 1, 32 do
				if player(ii,"exists") then
					if ii~=i then
						parse("hudtxt2 "..ii.." "..id.." \""..txt.."\" "..(320+(player(i,"x")-player(ii,"x")+x)).." "..(240+(player(i,"y")-player(ii,"y")+y)).." "..(align or 0))
					else
						parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..320+x.." "..240+y.." "..(align or 0))
					end
				end
			end
		else
			for _, ii in pairs(ply) do
				if player(ii,"exists") then
					if ii~=i then
						parse("hudtxt2 "..ii.." "..id.." \""..txt.."\" "..(320+(player(i,"x")-player(ii,"x")+x)).." "..(240+(player(i,"y")-player(ii,"y")+y)).." "..(align or 0))
					else
						parse("hudtxt2 "..i.." "..id.." \""..txt.."\" "..320+x.." "..240+y.." "..(align or 0))
					end
				end
			end
		end
	end
end})

function textcolor(tid,r,g,b)
	local colour
	if type(r)=="string" and not g and not b then
		colour = r
	else
		colour = colourcode(r,g,b)
	end
	
	if maptext.hudtxts[tid][1]:sub(1,1) ~= "\169" then
		maptext.hudtxts[tid][1] = "\169" .. colour .. maptext.hudtxts[tid][1]
	else
		maptext.hudtxts[tid][1] = "\169" .. colour .. maptext.hudtxts[tid][1]:sub(11)
	end
	
	if (maptext.hudtxts[tid][6] ~= 1) then
		for _, id in pairs(player(0,"table")) do
			movetext(id,player(id,"x"),player(id,"y"))
		end
	else
		if (maptext.hudtxts[tid][4] == 0) then
			for i = 1, 32 do
				parse("hudtxt2 "..i.." "..tid.." \""..maptext.hudtxts[tid][1].."\" "..maptext.hudtxts[tid][2].." "..maptext.hudtxts[tid][3].." "..maptext.hudtxts[tid][5])
			end
		elseif (type(maptext.hudtxts[tid][4])=="table") then
			for _, i in pairs(maptext.hudtxts[tid][4]) do
				parse("hudtxt2 "..i.." "..tid.." \""..maptext.hudtxts[tid][1].."\" "..maptext.hudtxts[tid][2].." "..maptext.hudtxts[tid][3].." "..maptext.hudtxts[tid][5])
			end
		end
	end
end

function textalpha(tid,alpha,dur)
	dur = dur or 0
	local t = maptext.hudtxts[tid]
	t[7] = alpha
	if (type(t[4])=="table") then
		for _, id in pairs(t[4]) do
			parse("hudtxtalphafade "..id.." "..tid.." "..dur.." "..alpha)
		end
	else
		if (t[4]==0) then
			for id = 1, 32 do
				parse("hudtxtalphafade "..id.." "..tid.." "..dur.." "..alpha)
			end
		end
	end
end



addhook("move","movetext")
function movetext(id,x,y)
	for tid, v in pairs(maptext.hudtxts) do
		if (type(v[4])=="table" and table.contains(v[4],id) or v[4]==0) then
			if (v[6] == 0) then
				parse("hudtxt2 "..id.." "..tid.." \""..v[1].."\" "..(320+(v[2]-x)).." "..(240+(v[3]-y)).." "..(v[5] or 0))
			elseif (v[6] > 100) then
				local did = v[6] - 100
				if (did == id) then
					for _, i in pairs(player(0,"table")) do
						parse("hudtxt2 "..i.." "..tid.." \""..v[1].."\" "..(320+(player(did,"x")-player(i,"x"))+v[2]).." "..(240+(player(did,"y")-player(i,"y"))+v[3]).." "..(v[5] or 0))
					end
				else
					parse("hudtxt2 "..id.." "..tid.." \""..v[1].."\" "..(320+(player(did,"x")-x)+v[2]).." "..(240+(player(did,"y")-y)+v[3]).." "..(v[5] or 0))
				end
			end
			if v[7] and v[7]~=1 then
				parse("hudtxtalphafade "..id.." "..tid.." 0 "..v[7])
			end
		end
	end
end